//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Orange
#property indicator_color2  LimeGreen
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -50
#property indicator_maximum +50
#property strict

//
//
//
//
//

extern int                RsiPeriod           = 14;          // RSI period
extern ENUM_APPLIED_PRICE RsiPrice            = PRICE_CLOSE; // RSI price
extern double             RsiLevelUp          = 75;          // RSI level up
extern double             RsiLevelDown        = 25;          // RSI level down
extern int                BollingerPeriod     = 20;          // Bollinger period
extern ENUM_APPLIED_PRICE BollingerPrice      = PRICE_CLOSE; // Bollinger price
extern double             BollingerDeviations = 1;           // Bollinger deviations
extern bool               alertsOn            = false;       // Turn alerts on
extern bool               alertsOnCurrent     = true;        // Alerts on still opened bar
extern bool               alertsMessage       = true;        // Alerts should show popup message
extern bool               alertsSound         = false;       // Alerts should play a sound
extern bool               alertsEmail         = false;       // Alerts should send email
extern bool               alertsPushNotif     = false;       // Alerts should send notification

double rsi[];
double histou[];
double histod[];
double state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,histou); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histod); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,rsi);
   SetIndexBuffer(3,state);
   IndicatorShortName("forex-tsd rsi + bollinger ("+(string)RsiPeriod+","+(string)BollingerPeriod+","+(string)BollingerDeviations+")");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted(); double price[3];
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
 	for(int i = limit; i>=0; i--)
 	{
 	    rsi[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i)-50;
 	    double sma = iMA(NULL,0,BollingerPeriod,0,MODE_SMA,BollingerPrice,i);
 	    double dev = iStdDev(NULL,0,BollingerPeriod,0,MODE_SMA,BollingerPrice,i);
 	      histou[i] = EMPTY_VALUE;
 	      histod[i] = EMPTY_VALUE;
 	      state[i]  = 0;
 	      if ((rsi[i]+50) > RsiLevelUp   && (sma+BollingerDeviations*dev)<Close[i]) histou[i] = rsi[i];
 	      if ((rsi[i]+50) < RsiLevelDown && (sma-BollingerDeviations*dev)>Close[i]) histod[i] = rsi[i];
         if (histou[i]!=EMPTY_VALUE) state[i] =  1;
         if (histod[i]!=EMPTY_VALUE) state[i] = -1;
   } 	       

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (state[whichBar] != state[whichBar+1])
      {
         if (state[whichBar] ==  1)  doAlert("up");
         if (state[whichBar] == -1)  doAlert("down");
      }
   }   
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" rsi + bollinger possible reversal "+doWhat;
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," rsi + bollinger"),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}